
package mini_turtle;

import java_cup.runtime.*;
import java.util.*;
import static mini_turtle.sym.*;

%%

%class Lexer
%unicode
%cup
%cupdebug
%line
%column
%yylexthrow Exception

%{

    /* Pour construire un lexème, on appelle l'une des deux méthodes "symbol"
    suivantes, en lui passant en argument un symbole de lexème introduit dans Parser
    (EOF, etc.) et éventuellement une valeur (entier, chaîne, etc.) */

    private Symbol symbol(int id)
    {
	return new Symbol(id, yyline, yycolumn);
    }

    private Symbol symbol(int id, Object value)
    {
	return new Symbol(id, yyline, yycolumn, value);
    }

%}

/* Ici on peut déclarer des raccourcis pour des expressions régulières,
   par exemple */
WhiteSpace         = [ \t\f\r\n]
/* À COMPLÉTER (si besoin) */

%%

/* Le point d'entrée de l'analyseur lexical. */

<YYINITIAL> {

    /* ici une liste d'expressions régulières, chacune suivie d'une action
    (du code Java) entre accolades. Cette action peut être vide (auquel cas
    l'analyseur est relancé) ou se terminer par return new Symbol(...); 
    pour renvoyer un lexème. */
    
    /* À COMPLÉTER */
    
    .
    { throw new Exception (String.format (
        "Line %d, column %d: illegal character: '%s'\n", yyline, yycolumn, yytext()
      ));
    }

}
